<template>
	<view>
		<view class="top-fixed" :style="'height:'+systems.barHeight +'rpx;'">
			<view class="top-c ddflex" :style="'margin-top:'+systems.ktxStatusHeight +'rpx;height:'+systems.navigationHeight +'rpx;'">
				<navigator open-type="navigateBack" class="top-back"><image :src="picUrlss+'back_black.png'"></image></navigator>
			</view>
		</view>
		<view class="map-box">
			<map :longitude="pois.poiLongitude" :latitude="pois.poiLatitude" :markers="covers" ref="map1" class="map" scale="16"></map>
		</view>
		<view class="map-info">
			<view class="map-infos ddflex">
				<view class="map-loc fflex">{{pois.poiName}}</view>
				<view class="map-num">{{commentCount}} 帖子</view>
			</view>
			<view class="map-add">{{pois.poiAddress}}</view>
			<block v-if="teamList.length>0">
			<view class="map-tits">附近的队伍</view>
			<view class="map-team">
				<scroll-view scroll-x="true" class="map-teams">
					<view class="li" v-for="(item,index) in teamList" :key="index" @click="jumpUrl('/office/team/index?id='+item.id)">
						<view class="ddflex">
							<image :src="item.url?item.url:picUrlss+'office_images/team_default.png'" mode="aspectFill"></image>
							<view class="fflex">
								<view class="tover">{{item.title}}</view>
								<text>{{item.memberNum}}成员</text>
							</view>
							<view class="li-btn" @click.stop="joinTeam(item,index)">{{item.isJoin == 1 ? '去看看':'加入'}}</view>
						</view>
					</view>
				</scroll-view>
			</view>
			</block>
		</view>
		<view class="cons-b">
			<view class="tab ddflex">
				<!-- <view :class="'li ' + (pType == 1 ? 'active' : '')" @click="swiPType(1)">综合</view> -->
				<!-- <view :class="'li ' + (cateIndex == index ? 'active' : '')" @click="swiTree(item,index)" v-for="(item,index) in category" :key="index">{{item.name}}</view> -->
				<view :class="'li ' + (pType == 12 ? 'active' : '')" @click="swiPType(12)">最新</view>
				<view :class="'li ' + (pType == 5 ? 'active' : '')" @click="swiPType(5)">热门</view>
			</view>
			<view class="list" v-if="officeList && officeList.length > 0">
				<view class="li" v-for="(item, index) in officeList" :key="index">
					<view class="user ddflex" @click="jumpUrl('/topics/home/home?userId=' + item.userDTO.id)">
						<image :src="item.userDTO.avatar?item.userDTO.avatar:'/static/images/def_head.png'" mode="aspectFill" class="userimg"></image>
						<view class="fflex">
							<view class="namea ddflex">
								<view class="name fflex ddflex">{{ item.userDTO.nickName }}
									<!-- <image src="../../static/images/vip_tag.png" class="vip-tag" v-if="item.userDTO.levelGrade > 0"></image> -->
									<image v-if="item.userDTO.isOpenWeRunData" style="width:15rpx;height:20rpx;margin-left: 10rpx;" src="../../static/images/yd.png"></image>
								</view>
								<view class="time">{{ item.time }}</view>
							</view>
							<view class="area" v-if="item.userDTO.cityName">{{ item.userDTO.provinceName }} {{ item.userDTO.cityName }}</view>
						</view>
					</view>
					<view class="des" @click="jumpUrlDetail(item)"><rich-text :nodes="item.content"></rich-text></view>
					<!-- //如果有投票，就不显示图片 -->
					<block v-if="!item.qyPoll">
					<view class="video" v-if="item.isHaveVideo && config.open_community_video == 1">
						<video :src="item.url" :show-center-play-btn="false" :controls="item.isControls" :autoplay="item.isControls" :id="'myVideo'+index" @pause="videoPause(index)" @ended="videoEnded(index)"></video>
						<view class="video-play ddflex" @click="videoPlay(index)" v-if="item.isShowPlayBtn"><image src="../../static/images/play.png"></image></view>
					</view>
					<view class="imgbox ddflex" @click="jumpUrlDetail(item)" v-if="!item.isHaveVideo"><!-- @click="previewImgss(item.url, idx)" -->
						<block v-if="item.url&&item.url.length>0">
							<image mode="aspectFill" v-for="(it, idx) in item.url" :src="it" :key="idx"></image>
						</block>
					</view>
					</block>
					<!-- 话题 -->
					<view class="ddflex" v-if="item.qyDialogu">
						<view class="topic ddflex" @click="jumpUrl('/topics/detail/detail?topicId=' + item.qyDialogu.id)">
							<image src="../../static/images/topic.png"></image>
							{{ item.qyDialogu.title }}
						</view>
					</view>
					<view class="loca ddflex" @click="jumpUrlPoi(item,'/office/poi/index')" v-if="item.poiName"><image :src="picUrlss+'office_images/loca.png'"></image><text v-if="item.poiDistance > 0">{{item.poiDistance ? item.poiDistance < 1000 ? item.poiDistance+'m' : (item.poiDistance/1000).toFixed(1)+'km' : ''}}</text>{{item.poiName}}</view>
					<!-- 投票 -->
					<view :class="'vote-box' + (item.qyPoll.isEnd ? ' ends' : '')" v-if="item.qyPoll">
						<view class="vote-tit">{{ item.qyPoll.title }}</view>
						<block v-if="item.qyPoll.isVote == 1">
							<view class="vote-list end" @click="jumpUrlDetail(item)">
								<view :class="'lis ddflex  ' + (itpy.isVote == 1 ? 'active' : '')" v-for="(itpy, idex) in JSON.parse(item.qyPoll.optionJson)" :key="idex">
									<view class="percent" :style="'width:' + parseFloat(itpy.proportion) + '%;'"></view>
									<view class="fflex">{{ itpy.name }}</view>
									<view>{{ parseFloat(itpy.proportion) + '%' }}</view>
								</view>
							</view>
						</block>
						<block v-else>
							<view class="vote-list">
								<view class="lis" v-for="(itpy, idex) in JSON.parse(item.qyPoll.optionJson)" :key="idex" @click="submitPoll(item, index, idex)">
									{{ itpy.name }}
								</view>
							</view>
						</block>
						<view class="vote-can" v-if="item.qyPoll.isEnd"><text>{{item.qyPoll.voteCount}}人参与</text>投票已结束</view>
					</view>
					<block v-if="item.type==10||item.type==11">
						<view v-if="item.type==10" class="ddflex step-box" style="justify-content: space-between;" @click="jumpUrl('/exercise/record/record?userId=' + item.userId)">
							<view>
								<view class="step-date">{{item.wxRun.step}}</view>
								<view class="step-label">步数</view>
							</view>
							<view>
								<view class="step-date">{{item.wxRun.index}}</view>
								<view class="step-label" style="text-align: right;">名次</view>
							</view>
						</view>
						<view v-if="item.type==11" class="ddflex step-box" style="justify-content: space-between;" @click="jumpUrl('/match/activityDetail/activityDetail?id=' + item.matchContent.id)">
							<image class="step-pic" :src="item.matchContent.pic" mode="aspectFill"></image>
							<view class="fflex">
								<view class="step-title tovers">{{item.matchContent.title}}</view>
								<view class="ddflex" style="justify-content: space-between;margin-top: 10rpx;">
									<view class="step-price">{{item.matchContent.endTime}}</view>
									<view  class="step-btn">查看</view>
								</view>
							</view>
						</view>
					</block>
					<view v-if="item.userGroupId" class="ddflex step-box" style="padding: 25rpx 21rpx;" @click="jumpUrl('/office/team/index?id=' + item.userGroupId)">
						<image style="width: 24rpx;height: 24rpx;margin-right: 13rpx;" src="../../static/images/link.png"></image>
						<view style="font-weight: 500;color: #999999;">Team：</view>
						<view>{{item.userGroupTitle}}</view>
					</view>
					<block v-else>
						<view class="product" v-if="item.products && item.products.length > 0">
							<view scroll-x="true" class="pro-view pro-view1" v-if="item.products.length == 1">
								<view class="lis" v-for="(it, idx) in item.products" :key="idx" @click="toProductDetail(it)">
									<view class="ddflex">
										<image :src="it.pic" mode="aspectFill" class="pic"></image>
										<view class="fflex">
											<view class="title tover">{{ it.title }}</view>
											<view class="opts ddflex">
												<view class="money"><text>￥</text>{{ it.salePrice }}</view>
												<view class="pro-btn"><image src="../../static/pages/images/n_cart.png"></image></view>
											</view>
										</view>
									</view>
								</view>
							</view>
							<scroll-view scroll-x="true" class="pro-view" v-else>
								<view class="lis" v-for="(it, idx) in item.products" :key="idx" @click="toProductDetail(it)">
									<view class="ddflex">
										<image :src="it.pic" mode="aspectFill" class="pic"></image>
										<view class="fflex">
											<view class="title tover">{{ it.title }}</view>
											<view class="opts ddflex">
												<view class="money"><text>￥</text>{{ it.salePrice }}</view>
												<view class="pro-btn"><image src="../../static/pages/images/n_cart.png"></image></view>
											</view>
										</view>
									</view>
								</view>
							</scroll-view>
						</view>
					</block>
					<view class="opt ddflex" v-if="!item.source">
						<view class="fflex" @click="jumpUrlDetail(item)">{{fomatNumbers(item.count.browseCount)}}次浏览</view>
						<view class="ddflex" @click="submitFabulous(2, item.id, index)">
							<image :src="'../../static/images/' + (item.isPraise == 1 ? 'like_h' : 'like') + '.png'"></image>
							{{fomatNumbers(item.count.fabulousCount)}}
						</view>
						<view class="ddflex" @click="jumpUrlDetail(item)">
							<image src="../../static/images/comment.png"></image>
							{{fomatNumbers(item.count.commentCount)}}
						</view>
						<button open-type="share" hover-class="none" class="opt-share ddflex">
							<image src="../../static/images/share.png"></image>
							分享
						</button>
					</view>
				</view>
			</view>
			<view class="nodata" v-else>
				<image :src="picUrlss + 'empty_jl.png'"></image>
				<text>暂无动态</text>
			</view>
		</view>
		<!-- <view class="create" @click="createJump('/office/news/news?newsType=4')" v-if="config.is_show_create_btn == 1"><image src="../../static/images/create.png"></image>发布</view> -->
		<!-- <view class="ceng" v-if="isShowbtn" @click="hideBtn"></view> @click="showBtn"
		<view class="side ddflex" v-if="isShowbtn">
			<view class="li" @click="createJump('/office/news/news?newsType=4')">
				<image src="../../static/images/ll_cz.png"></image>
				<view>图文</view>
			</view>
			<view class="li" @click="createJump('/office/news/news?newsType=4?isVideo=true')">
				<image src="../../static/images/ll_dt.png"></image>
				<view>视频</view>
			</view>
		</view> -->
	</view>
</template>

<script>
	const app = getApp();
	const api = require('../../utils/api.js');
	const req = require('../../utils/request.js');
	const util = require('../../utils/util.js');
	const QQMapWX = require("../../utils/qqmap.js");
	export default {
		components: {
		},
		data() {
			return {
				systems: {},
				isShowbtn: false,
				isShowPage: false,
				picUrlss: req.public.picUrls,
				opt: {},
				map: '',
				covers: [],
				pois: {},
				isLoad: true,
				form: {
					page: 1,
					limit: 10
				},
				pType: 12, //排序： 1综合, 2最新+综合,3浏览最多,4评论最多,5热门，10最新+标签，12最新
				isHoleLoad: true,
				holeForm: {
					page: 1,
					limit: 10
				},
				holeType: 1, //排序： 1综合, 2最新,3浏览最多,4评论最多,5热门
				hotTopicList: [],
				hotPollList: [],
				officeList: [], //聊一聊
				commentCount: 0,
				config: {},
				videoCurrent: null,
				videoContext: '',
				category: [],
				cateIndex: -1,
				treeId: '',
				teamList: []
			}
		},
		onLoad(options) {
			this.opt = options;
			let pages = getCurrentPages(); //获取所有页面栈实例列表
			let prevPage = pages[pages.length - 2]; //上一页页面实例
			if(prevPage){
				this.pois = prevPage.$vm.currentPoi;
			}
			this.map = uni.createMapContext("map1", this);
			let points = {
				latitude: this.pois.poiLatitude,
				longitude: this.pois.poiLongitude
			}
			let obj = {
				id: 0,
				latitude: this.pois.poiLatitude,
				longitude: this.pois.poiLongitude,
				width: 20,
				height: 30,
			}
			this.covers.push(obj);
			this.map.moveToLocation(points,res=>{
				console.log('地图',res)
			})
			this.getTeamPage();
			this.getOfficeList();
		},
		onReachBottom() {
			this.form.page++;
			this.getOfficeList();
		},
		methods: {
			//聊一聊切换排序类型
			swiPType(type) {
				this.isLoad = true;
				this.form.page = 1;
				this.pType = type;
				this.cateIndex = -1
				this.treeId = ''
				this.getOfficeList();
			},
			//预览图片
			previewImgss(picUrls, index) {
				//预览合同图片
				var src = picUrls[index];
				let imgs = picUrls;
				uni.previewImage({
					current: src, // 当前显示图片的http链接
					urls: imgs
				});
			},
	
			showBtn() {
				if (!req.isLogins(true)) {
					return;
				}
				this.isShowbtn = true;
			},
			hideBtn() {
				this.isShowbtn = false;
			},
	
			removeHtml(content) {
				return util.removeHtml(content);
			},
			createJump(url) {
				if (!req.isLogins(true)) {
					return;
				}
				this.jumpUrl(url);
			},
			jumpUrl(url){
				uni.navigateTo({
					url: url
				})
			},
			jumpUrlPoi(item,url){
				this.currentPoi = item;
				uni.navigateTo({
					url: url
				})
			},
			joinTeam(item,index){
				if(item.isJoin == 1) {
					uni.navigateTo({
						url: '/office/team/index?id='+item.id
					})
					return false;
				}
				if(item.relationMatch){
					uni.navigateTo({
						url: '/match/activityDetail/activityDetail?id='+item.relationMatch.id
					})
					return false;
				}
				req.postRequest(api.user_team_follow,{userGroupId: item.id},data=>{
					req.msg('加入团队成功');
					this.teamList[index].isJoin = 1;
				})
			},
			jumpToPractice(item,url){
				let checkCategory = {
					id: item.question.cateId,
					name: item.question.cateName
				}
				req.setStorage('checkCategory',checkCategory)
				this.jumpUrl(url);
			},
			jumpUrlDetail(item) {
				this.jumpUrl('/office/detail/detail?contentId=' + item.id);
			},
			toProductDetail(item) {
				this.jumpUrl('/product/detail/detail?id=' + item.id);
			},
			getTeamPage(){
				let form = {
					page: 1,
					limit: 5,
					poiLongitude: this.pois.poiLongitude,
					poiLatitude: this.pois.poiLatitude
				}
				console.log('加载团队',form)
				req.getRequest(api.user_team_page,form,data=>{
					this.teamList = data.list;
				})
			},
			swiTree(item,index){
				if(this.cateIndex == index) return false;
				this.cateIndex = index;
				this.pType = -1;
				this.treeId = item.id;
				this.form.page = 1;
				this.isLoad = true;
				this.getOfficeList()
			},
			sum(arr) {
				var s = 0;
				for (var i=arr.length-1; i>=0; i--) {
					if(arr[i].count){
						s += Number(arr[i].count);
					}
				}
				return s;
			},
			fomatNumbers(num){
				return util.formatNumbers(num)
			},
			getOfficeList() {
				let that = this;
				var pramData = {};
				pramData.page = this.form.page;
				pramData.limit = this.form.limit;
				pramData.distance = 20000;//限制距离，单位米
				// pramData.type = 4;
				if (this.pType == 5) {
					//热门
					pramData.isEssence = 2;
					pramData.orderType = 1;
				} else {
					pramData.orderType = this.pType;
				}
				if(this.treeId) {
					pramData.treeId = this.treeId
					pramData.orderType = 1
				}else delete pramData.treeId
				pramData.poiLongitude = this.pois.poiLongitude;
				pramData.poiLatitude = this.pois.poiLatitude;
				// pramData.poiName = this.pois.poiName;
				
				if (!this.isLoad) return false;
				this.isLoad = false;
				if(pramData.page == 1){
					uni.showLoading({
						mask: true
					})
				}
				req.getRequest('/api/v3/moments/page', pramData, data => {
					if(data.list&&data.list.length > 0){
						data.list.map(it=>{
							if(it.qyPoll && it.qyPoll.isEnd){
								it.qyPoll.voteCount = that.sum(JSON.parse(it.qyPoll.optionJson))
							}
							if(it.url){
								let h = it.url.substring(it.url.lastIndexOf('.') + 1)
								if(h.indexOf('mp4')<0&&h.indexOf('MP4')<0){
									it.url = it.url.split(',');
								}else{
									it.isHaveVideo = true
									it.isControls = false
									it.isShowPlayBtn = true
								}
							}
							it.content = '<div style="overflow: hidden;text-overflow: ellipsis;display: -webkit-box;-webkit-line-clamp: 5;-webkit-box-orient: vertical;word-break: break-all;">' + it.content + '</div>'
							return it;
						})
					}
					if (data.list && data.list.length >= 10) {
						this.isLoad = true;
					}
					if (this.form.page > 1) {
						data.list = this.officeList.concat(data.list);
					} else {
						this.officeList = [];
					}
					this.officeList = data.list;
					if(this.pType == 12){
						this.commentCount = data.total;
					}
					this.isShowPage = true;
					uni.hideLoading();
				});
			},
			//提交点赞、取消点赞；收藏、取消收藏
			submitFabulous(type, id, index) {
				if (!req.isLogins(true)) {
					return;
				}
				var dataP = {};
				dataP.type = type; //1，观看 ，2点赞，3评论，4分享，5收藏
				dataP.momentsId = id;
				req.postRequestLoding('/api/v3/fabulous/save', dataP, data => {
					if (type == 2) {
						//动态点赞
						if (this.officeList[index].isPraise == 1) {
							//已赞
							this.officeList[index].isPraise = 0;
							this.officeList[index].count.fabulousCount--;
							req.saveBehaviorNew(id, this.officeList[index].pollId?10:11,11)
						} else {
							this.officeList[index].isPraise = 1;
							this.officeList[index].count.fabulousCount++;
							req.saveBehaviorNew(id, this.officeList[index].pollId?10:11,3)
						}
					}
				});
			},
	
			//提交投票
			submitPoll(item, pIndex, pollIndex) {
				if(item.qyPoll.isEnd){
					this.jumpUrlDetail(item)
					return false;
				} 
				var dataP = {};
				// dataP.id = item.id;
				dataP.pollId = item.qyPoll.id;
				var pollObjList = JSON.parse(item.qyPoll.optionJson);
				dataP.pollOptionCode = pollObjList[pollIndex].code;
				req.postRequest('/api/v3/poll/saveDetails', dataP, data => {
					req.msg('投票成功');
					//图片完之后要将该投票的对象返回，便于做渲染%
					this.officeList[pIndex].qyPoll = data;
					req.saveBehaviorNew(item.id,10,5)
				});
			},
			goTop: function(e) {
				// 一键回到顶部
				if (uni.pageScrollTo) {
					uni.pageScrollTo({
						scrollTop: 0
					});
				} else {
					uni.showModal({
						title: '提示',
						content: '当前微信版本过低，无法使用该功能，请升级到最新微信版本后重试。'
					});
				}
			},
			videoPlay(index){
			    var that = this;
			    var curIdx = index;
			    this.officeList[index].isControls = true
			    this.officeList[index].isShowPlayBtn = false
			    // 有播放时先将prev暂停，再播放当前点击的current
			    if (that.videoCurrent != null) {
					var videoContextPrev = uni.createVideoContext('myVideo' + that.videoCurrent)
					if (that.videoCurrent != curIdx) {
						this.officeList[that.videoCurrent].isControls = false
						this.officeList[that.videoCurrent].isShowPlayBtn = true
						
						videoContextPrev.stop()
					}
					that.videoCurrent = curIdx
					var videoContextCurrent = uni.createVideoContext('myVideo' + curIdx)
					videoContextCurrent.play()
			    } else {  
					// 没有播放时播放视频
					that.videoCurrent = curIdx
					var videoContext = uni.createVideoContext('myVideo' + curIdx) // 对应的视频id
					videoContext.play()
			    }
			},
			videoPause(index){
				this.officeList[index].isControls = false
				this.officeList[index].isShowPlayBtn = true
			},
			videoEnded(index){
				this.officeList[index].isControls = false
				this.officeList[index].isShowPlayBtn = true
			}
		},
		created() {
			const systemInfo = uni.getSystemInfoSync();
			// px转换到rpx的比例
			let pxToRpxScale = 750 / systemInfo.windowWidth;
			let systems = {
				ktxStatusHeight: systemInfo.statusBarHeight * pxToRpxScale, // 状态栏的高度
				navigationHeight: 44 * pxToRpxScale // 导航栏的高度
			};
			systems.barHeight = systems.ktxStatusHeight + systems.navigationHeight;
			this.systems = systems;
		},
	}
</script>

<style>
	@import "./index.css";
</style>
